"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _codeSurfer = _interopRequireDefault(require("code-surfer"));

var _react = _interopRequireDefault(require("react"));

var _mdxDeck = require("mdx-deck");

var _styledComponents = require("styled-components");

var _memoizeOne = _interopRequireDefault(require("memoize-one"));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj &&
        typeof Symbol === "function" &&
        obj.constructor === Symbol &&
        obj !== Symbol.prototype
        ? "symbol"
        : typeof obj;
    };
  }
  return _typeof(obj);
}

function _extends() {
  _extends =
    Object.assign ||
    function(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
  return _extends.apply(this, arguments);
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _slicedToArray(arr, i) {
  return (
    _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest()
  );
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;
  try {
    for (
      var _i = arr[Symbol.iterator](), _s;
      !(_n = (_s = _i.next()).done);
      _n = true
    ) {
      _arr.push(_s.value);
      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }
  return _arr;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  }
  return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf
    ? Object.getPrototypeOf
    : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
  return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError(
      "this hasn't been initialised - super() hasn't been called"
    );
  }
  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: { value: subClass, writable: true, configurable: true }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf =
    Object.setPrototypeOf ||
    function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
  return _setPrototypeOf(o, p);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var Notes = function Notes(_ref) {
  var notes = _ref.notes;
  return !notes || typeof notes === "string"
    ? _react["default"].createElement(
        "p",
        {
          style: {
            height: "50px"
          }
        },
        notes || "\xA0"
      )
    : notes();
};

var Title = function Title(_ref2) {
  var title = _ref2.title;
  return typeof title === "string"
    ? _react["default"].createElement("h1", null, title)
    : title();
};

var InnerCodeSurfer =
  /*#__PURE__*/
  (function(_React$Component) {
    _inherits(InnerCodeSurfer, _React$Component);

    function InnerCodeSurfer(props) {
      var _this;

      _classCallCheck(this, InnerCodeSurfer);

      _this = _possibleConstructorReturn(
        this,
        _getPrototypeOf(InnerCodeSurfer).call(this, props)
      );

      _defineProperty(
        _assertThisInitialized(_this),
        "parseSteps",
        (0, _memoizeOne["default"])(function(steps, notes) {
          if (!steps) {
            return [
              {
                notes: notes
              }
            ];
          }

          if (typeof steps === "string") {
            return steps
              .trim()
              .split("\n")
              .map(function(stepAndNoteString) {
                var _stepAndNoteString$sp = stepAndNoteString.split("> "),
                  _stepAndNoteString$sp2 = _slicedToArray(
                    _stepAndNoteString$sp,
                    2
                  ),
                  step = _stepAndNoteString$sp2[0],
                  notes = _stepAndNoteString$sp2[1];

                return {
                  step: step,
                  notes: notes
                };
              });
          }

          return steps.map(function(_ref3) {
            var notes = _ref3.notes,
              title = _ref3.title,
              step = _objectWithoutProperties(_ref3, ["notes", "title"]);

            return {
              step: step,
              notes: notes,
              title: title
            };
          });
        })
      );

      var _props$deck = props.deck,
        update = _props$deck.update,
        index = _props$deck.index;

      var parsedSteps = _this.parseSteps(props.steps);

      var maxStep = parsedSteps.length - 1;
      update(_mdxDeck.updaters.setSteps(index, maxStep));
      return _this;
    }

    _createClass(InnerCodeSurfer, [
      {
        key: "shouldComponentUpdate",
        value: function shouldComponentUpdate(nextProps) {
          return !!nextProps.deck.active;
        }
      },
      {
        key: "render",
        value: function render() {
          var _this$props = this.props,
            code = _this$props.code,
            steps = _this$props.steps,
            title = _this$props.title,
            notes = _this$props.notes,
            theme = _this$props.theme,
            prismTheme = _this$props.prismTheme,
            showNumbers = _this$props.showNumbers,
            rest = _objectWithoutProperties(_this$props, [
              "code",
              "steps",
              "title",
              "notes",
              "theme",
              "prismTheme",
              "showNumbers"
            ]);

          var stepIndex = this.props.deck.step || 0;
          var mdxDeckTheme = theme;
          prismTheme = prismTheme || mdxDeckTheme.codeSurfer;
          showNumbers = showNumbers || (prismTheme && prismTheme.showNumbers);
          var stepsWithNotes = this.parseSteps(steps, notes);
          var current =
            stepsWithNotes[stepIndex >= stepsWithNotes.length ? 0 : stepIndex];
          var currentStep = current.step;
          var currentTitle = current.title || title;
          var currentNotes = current.notes;
          var anyNotes = stepsWithNotes.some(function(s) {
            return s.notes;
          });
          return _react["default"].createElement(
            "div",
            {
              style: {
                height: "100vh",
                width: "100vw",
                background: prismTheme && prismTheme.plain.backgroundColor,
                color: prismTheme && prismTheme.plain.color,
                display: "flex",
                alignItems: "center",
                justifyContent: "center"
              }
            },
            _react["default"].createElement(
              "div",
              {
                style: {
                  height: "100vh",
                  display: "flex",
                  flexDirection: "column",
                  justifyContent: "center"
                }
              },
              currentTitle &&
                _react["default"].createElement(Title, {
                  title: currentTitle
                }),
              _react["default"].createElement(
                "div",
                {
                  style: {
                    flexGrow: 1,
                    display: "flex",
                    alignItems: "center",
                    overflow: "hidden"
                  },
                  key: "code"
                },
                _react["default"].createElement(
                  _codeSurfer["default"],
                  _extends({}, rest, {
                    code: code,
                    showNumbers: showNumbers,
                    step: currentStep,
                    theme: prismTheme,
                    monospace: mdxDeckTheme && mdxDeckTheme.monospace
                  })
                )
              ),
              anyNotes &&
                _react["default"].createElement(Notes, {
                  notes: currentNotes
                }),
              _react["default"].createElement("div", {
                style: {
                  height: "35px"
                }
              })
            )
          );
        }
      }
    ]);

    return InnerCodeSurfer;
  })(_react["default"].Component); // Things I need to do to avoid props name collisions

var EnhancedCodeSurfer = (0, _mdxDeck.withDeck)(
  (0, _styledComponents.withTheme)(InnerCodeSurfer)
);

var _default = function _default(_ref4) {
  var theme = _ref4.theme,
    rest = _objectWithoutProperties(_ref4, ["theme"]);

  return _react["default"].createElement(
    EnhancedCodeSurfer,
    _extends({}, rest, {
      prismTheme: theme
    })
  );
};

exports["default"] = _default;
